(* Heterogeneous list *)
type empty = Empty;;

let cons x y = x,y;;
let nil = Empty;;

let singleton x = cons x nil;;

let l = cons 1 (cons true Empty);;
let ll = cons true Empty;;

generic rec append = case
| empty -> $a -> $a => (fun l1 l2 -> l2)
| ($a * $b) -> $c -> ($a * $d) =>
   (fun (h1, l1) l2 ->
     cons h1 (append l1 l2));;

append l l;;

(* 99/10/29 : Problem (see listrev.tex) *)
generic rec rev = case
| empty -> empty => (fun l -> l)
| $a * $b -> $c * $d => (fun (h, l) -> append (rev l) (singleton h))
;;

rev l;;

(* IT WORKS !!! *)
generic rec rev_append = case
| empty -> $a -> $a => (fun _ l -> l)
| $a * empty -> $c -> $a * $c => 
    (fun (h,_) l -> cons h l)
| $a * ($b * $e) -> $c -> $d => 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

(* IT WORKS ALSO (and simpler) *)
generic rec rev_append = case
| empty -> $a -> $a => (fun _ l -> l)
| $a * $b -> $c -> $d => 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

let rev2 = fun l -> rev_append l Empty;;

(* BELOW, THEY DO NOT WORK BECAUSE WE SPECIFIED TOO MUCH INFORMATION 
   We restrict the polymorphism by adding too much constraints.

generic rec rev_append = case $a -> $b -> $c of
| << empty -> $a -> $a >> -> (fun _ l -> l)
| << $a * $b -> $c -> $d * ($a * $c) >> -> 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

generic rec rev_append = case $a -> $b -> $c of
| << empty -> $a -> $a >> -> (fun _ l -> l)
| << $a * empty -> $c -> $a * $c >> -> 
    (fun (h,_) l -> cons h l)
| << $a * ($b * $e) -> $c -> $d * ($a * $c) >> -> 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

generic rec rev_append = case $a -> $b -> $c of
| << empty -> $a -> $a >> -> (fun _ l -> l)
| << $a * empty -> $c -> $a * $c >> -> 
    (fun (h,_) l -> cons h l)
| << $a * ($b * $e) -> $c -> $d * ($a * $c) >> -> 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

generic rec rev_append = case $a -> $b -> $c of
| << $a * empty -> $c -> $a * $c >> -> 
    (fun (h,_) l -> cons h l)
| << $a * ($b * $e) -> $c -> $d * ($a * $c) >> -> 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;

generic rev = case $a -> $b of
| << empty -> empty >> -> (fun x -> x)
| << ($a * $b) -> ($c * $d) >> -> (fun l -> rev_append l Empty)
;;

generic rec rev_append = case $a -> $b -> $c of
| << $a * empty -> $c -> $a * $c >> -> 
    (fun (h,_) l -> cons h l)
| << $a * ($b * $e) -> $c -> $d * ($a * $c) >> -> 
    (fun (h,t) l ->
      rev_append t (cons h l))
;;
*)

generic rec map = case
| ($b -> $c) -> empty -> empty => (fun f _ -> Empty)
| ($b -> $c) -> ($b * $e) -> ($c * $g) =>
    (fun f (h,t) -> cons (f h) (map f t))
;;

generic rec map = case 
| (dyn -> dyn) -> empty -> empty => (fun f _ -> Empty)
| (dyn -> dyn) -> ($a * $b) -> (dyn * $d) =>
    (fun f (h,t) -> cons (f (dyn h)) (map f t))
;;

let f = fun x -> x;;

map f l3;;


(* maybe in future ...
generic rec map = case (dyn -> dyn) -> $a -> $b of
| << (dyn -> dyn) -> empty -> empty >> -> (fun f _ -> Empty)
| << (dyn -> dyn) -> ($a * $b) -> (dyn * $d) >> ->
    (fun f (h,t) -> cons (coerce (f (dyn h)) : $?) (map f t))
;;
*)
