(* We add anything ! *)
generic ( + ) = case $a -> $a -> $a of 
  << int ->     int ->     int >> -> ( + )
| << float ->   float ->   float >> -> ( +. )
;;

generic ( - ) = case $a -> $a -> $a of 
  << int ->     int ->     int >> -> ( - )
| << float ->   float ->   float >> -> ( -. )
;;

generic ( * ) = case $a -> $a -> $a of 
  << int ->     int ->     int >> -> ( * )
| << float ->   float ->   float >> -> ( *. )
;;

generic ( / ) = case $a -> $a -> $a of 
  << int ->     int ->     int >> -> ( / )
| << float ->   float ->   float >> -> ( /. )
;;

generic one = case $a of
| << int >> -> 1
| << float >> -> 1.0
;;

let square x = x * x
;;

let rec power n = function (* n^(p : int) *)
  | 0 -> one
  | 1 -> n
  | p -> 
      let q,r = p / 2, p mod 2 in
      if r = 0 then square (power n q)
      else square (power n q) * n
;;
    
(*
  power : $a -> int -> $a [ $a -> int -> $a & ( * ) : $a -> $a -> $a 
         & square : $a -> $a
         & power : $a -> int -> $a ] ----> Now removed !!!!
*)

let rec power n = function (* n^(p : int) *)
  | 0 -> one
  | 1 -> n
  | p -> power n (p-1) * n
;;

generic rec power = case $a -> int -> $a of
  | << int -> int -> int >> ->
      (fun n p -> 
	match p with
	| 0 -> one
	| 1 -> n 
	| _ -> power n (p-1) * n)
  | << float -> int -> float >> ->
      (fun n p -> 
	match p with
	| 0 -> one
	| 1 -> n 
	| _ -> power n (p-1) * n)
;;
